#ifndef __TITLE_GEN_FEATURE_VECTOR__
#define __TITLE_GEN_FEATURE_VECTOR__

#include <list>
#include <map>
#include <iostream>
#include "hash_map.hpp"
#include "nlp_string.h"
#include "Section.h"
#include "LanguageModel.h"
#include "Features.h"
using namespace std;


//-------------------------------------------------------------------
#define AddFeature(feature,value)	if (value == 0); else arr_Features [feature] = value


class Model;
class Path;
class TreePath;
class SectionTitle;
typedef hash_map <String, double>	FeatureValue_map_t;


//-------------------------------------------------------------------
class FeatureVector
{
	private:
		static LanguageModel* p_TagLM;
		static LanguageModel* p_LexicalLM;
		static Section_list_t*	plst_AllSections;
		static Section* p_RootSection;
		static Section* p_Section;
		static Word*	p_EndWord;
		static Word*	p_StartWord;
		static int i_SectionCount;
		static int i_WindowSize;
		static bool b_UseWordAndTagLM;

		void AddPosTagFeature (String& _sTag, double _dValue);
    
	public:
		static int gi_Count;
		static bool b_UseHierarchicalFeatures;
		double arr_Features [FEATURE_COUNT];
		
		FeatureVector (void);
		FeatureVector (FeatureVector& _rOld);
		~FeatureVector (void);

		static void Init (Model& _rModel, Section* _pSection);
		void CreateTreeFeatures (TreePath* _pTocPath, 
								 Path* _pSectionPath, 
								 SectionTitle* _pSectionTitle,
								 int _iSectionBeamIndex,
								 int _iBeamWidth);
		void CreateFeatures (Path* _pPath, Word* _pWord);
		void Clear (void);
		void Save (const char* _zFileName, const char* _zTag, bool _bHierarchical);
};


#include "Model.h"
#endif
