#ifndef __FEATURE_LIST_HEADER__
#define __FEATURE_LIST_HEADER__


// list of basic section features	

#define ETLM		0
#define TLM			1
#define L2LM		2
#define LLM			3
#define ISW			4
#define IAW			5
#define PSHS		6
#define NSHS		7
#define PHS			8
#define STFIDF		9
#define ATFIDF		10
#define TFIDF		11
#define FOBSN		12
#define FOBS0		13
#define FOBS1		14
#define TFIDF1		15
#define FOBS2		16
#define TFIDF2		17
#define FOBS3		18
#define TFIDF3		19
#define FOBW		20
#define NPR			21
#define PT_LRB		22
#define PT_RRB		23
#define PT_CC		24
#define PT_CD		25
#define PT_DT		26
#define PT_EX		27
#define PT_FW		28
#define PT_IN		29
#define PT_JJ		30
#define PT_JJR		31
#define PT_JJS		32
#define PT_LS		33
#define PT_MD		34
#define PT_NN		35
#define PT_NNP		36
#define PT_NNPS		37
#define PT_NNS		38
#define PT_PDT		39
#define PT_POS		40
#define PT_PRP$		41
#define PT_RB		42
#define PT_RBR		43
#define PT_RBS		44
#define PT_RP		45
#define PT_TO		46
#define PT_UH		47
#define PT_VB		48
#define PT_VBD		49
#define PT_VBG		50
#define PT_VBN		51
#define PT_VBP		52
#define PT_VBZ		53
#define PT_WDT		54
#define PT_WP		55
#define PT_WP$		56
#define PT_WRB		57

// list of basic TOC features		
#define H_SPS		58
#define HP_ST		59
#define HP_SS		60
#define HP_SFW		61
#define HP_SLW		62
#define HP_CS		63
#define HP_TM		64
#define HS_ST		65
#define HS_SSM		66
#define HS_SSA		67
#define HS_SFW		68
#define HS_SLW		69
#define HS_CS		70
#define HS_TMA		71
#define H_DT		72
#define H_SPR		73
#define HPRE_SS		74
#define HPRE_ST		75
#define HC_ST		76
#define HPRE2_ST	77
#define HR_JJE		78
#define H_SPSL		79


// feature counts...		
#define BASE_FEATURE_COUNT			80
#define FEATURE_COUNT				2 * BASE_FEATURE_COUNT
#define AVERAGE_FEATURE_OFFSET		BASE_FEATURE_COUNT


// list of section average features...
#define A_ETLM		ETLM + BASE_FEATURE_COUNT
#define A_TLM		TLM + BASE_FEATURE_COUNT
#define A_L2LM		L2LM + BASE_FEATURE_COUNT
#define A_LLM		LLM + BASE_FEATURE_COUNT
#define A_ISW		ISW + BASE_FEATURE_COUNT
#define A_IAW		IAW + BASE_FEATURE_COUNT
#define A_PSHS		PSHS + BASE_FEATURE_COUNT
#define A_NSHS		NSHS + BASE_FEATURE_COUNT
#define A_PHS		PHS + BASE_FEATURE_COUNT
#define A_STFIDF	STFIDF + BASE_FEATURE_COUNT
#define A_ATFIDF	ATFIDF + BASE_FEATURE_COUNT
#define A_TFIDF		TFIDF + BASE_FEATURE_COUNT
#define A_FOBSN		FOBSN + BASE_FEATURE_COUNT
#define A_FOBS0		FOBS0 + BASE_FEATURE_COUNT
#define A_FOBS1		FOBS1 + BASE_FEATURE_COUNT
#define A_TFIDF1	TFIDF1 + BASE_FEATURE_COUNT
#define A_FOBS2		FOBS2 + BASE_FEATURE_COUNT
#define A_TFIDF2	TFIDF2 + BASE_FEATURE_COUNT
#define A_FOBS3		FOBS3 + BASE_FEATURE_COUNT
#define A_TFIDF3	TFIDF3 + BASE_FEATURE_COUNT
#define A_FOBW		FOBW + BASE_FEATURE_COUNT
#define A_NPR		NPR + BASE_FEATURE_COUNT
#define A_PT_LRB	PT_LRB + BASE_FEATURE_COUNT
#define A_PT_RRB	PT_RRB + BASE_FEATURE_COUNT
#define A_PT_CC		PT_CC + BASE_FEATURE_COUNT
#define A_PT_CD		PT_CD + BASE_FEATURE_COUNT
#define A_PT_DT		PT_DT + BASE_FEATURE_COUNT
#define A_PT_EX		PT_EX + BASE_FEATURE_COUNT
#define A_PT_FW		PT_FW + BASE_FEATURE_COUNT
#define A_PT_IN		PT_IN + BASE_FEATURE_COUNT
#define A_PT_JJ		PT_JJ + BASE_FEATURE_COUNT
#define A_PT_JJR	PT_JJR + BASE_FEATURE_COUNT
#define A_PT_JJS	PT_JJS + BASE_FEATURE_COUNT
#define A_PT_LS		PT_LS + BASE_FEATURE_COUNT
#define A_PT_MD		PT_MD + BASE_FEATURE_COUNT
#define A_PT_NN		PT_NN + BASE_FEATURE_COUNT
#define A_PT_NNP	PT_NNP + BASE_FEATURE_COUNT
#define A_PT_NNPS	PT_NNPS + BASE_FEATURE_COUNT
#define A_PT_NNS	PT_NNS + BASE_FEATURE_COUNT
#define A_PT_PDT	PT_PDT + BASE_FEATURE_COUNT
#define A_PT_POS	PT_POS + BASE_FEATURE_COUNT
#define A_PT_PRP$	PT_PRP$ + BASE_FEATURE_COUNT
#define A_PT_RB		PT_RB + BASE_FEATURE_COUNT
#define A_PT_RBR	PT_RBR + BASE_FEATURE_COUNT
#define A_PT_RBS	PT_RBS + BASE_FEATURE_COUNT
#define A_PT_RP		PT_RP + BASE_FEATURE_COUNT
#define A_PT_TO		PT_TO + BASE_FEATURE_COUNT
#define A_PT_UH		PT_UH + BASE_FEATURE_COUNT
#define A_PT_VB		PT_VB + BASE_FEATURE_COUNT
#define A_PT_VBD	PT_VBD + BASE_FEATURE_COUNT
#define A_PT_VBG	PT_VBG + BASE_FEATURE_COUNT
#define A_PT_VBN	PT_VBN + BASE_FEATURE_COUNT
#define A_PT_VBP	PT_VBP + BASE_FEATURE_COUNT
#define A_PT_VBZ	PT_VBZ + BASE_FEATURE_COUNT
#define A_PT_WDT	PT_WDT + BASE_FEATURE_COUNT
#define A_PT_WP		PT_WP + BASE_FEATURE_COUNT
#define A_PT_WP$	PT_WP$ + BASE_FEATURE_COUNT
#define A_PT_WRB	PT_WRB + BASE_FEATURE_COUNT

// list of TOC average features		
#define A_H_SPS		H_SPS + BASE_FEATURE_COUNT
#define A_HP_ST		HP_ST + BASE_FEATURE_COUNT
#define A_HP_SS		HP_SS + BASE_FEATURE_COUNT
#define A_HP_SFW	HP_SFW + BASE_FEATURE_COUNT
#define A_HP_SLW	HP_SLW + BASE_FEATURE_COUNT
#define A_HP_CS		HP_CS + BASE_FEATURE_COUNT
#define A_HP_TM		HP_TM + BASE_FEATURE_COUNT
#define A_HS_ST		HS_ST + BASE_FEATURE_COUNT
#define A_HS_SSM	HS_SSM + BASE_FEATURE_COUNT
#define A_HS_SSA	HS_SSA + BASE_FEATURE_COUNT
#define A_HS_SFW	HS_SFW + BASE_FEATURE_COUNT
#define A_HS_SLW	HS_SLW + BASE_FEATURE_COUNT
#define A_HS_CS		HS_CS + BASE_FEATURE_COUNT
#define A_HS_TMA	HS_TMA + BASE_FEATURE_COUNT
#define A_H_DT		H_DT + BASE_FEATURE_COUNT
#define A_H_SPR		H_SPR + BASE_FEATURE_COUNT
#define A_HPRE_SS	HPRE_SS + BASE_FEATURE_COUNT
#define A_HPRE_ST	HPRE_ST + BASE_FEATURE_COUNT
#define A_HC_ST		HC_ST + BASE_FEATURE_COUNT
#define A_HPRE2_ST	HPRE2_ST + BASE_FEATURE_COUNT
#define A_HR_JJE	HR_JJE + BASE_FEATURE_COUNT
#define A_H_SPSL	H_SPSL + BASE_FEATURE_COUNT


#endif
