#ifndef __TITLE_GEN_LANGUAGE_MODEL__
#define __TITLE_GEN_LANGUAGE_MODEL__

#include <map>
#include "nlp_string.h"
#include "hash_map.hpp"
#include "Reader.h"
#include "Section.h"


typedef hash_map <String, double>	Weight_by_Ngram_map_t;
typedef list <String>				Unigram_list_t;
typedef list <Sentence*>    	    Sentence_list_t;


//--------------------------------------------------------
class LanguageModel
{
	private:
		Weight_by_Ngram_map_t map_BackoffWeight_by_Ngram;
		Weight_by_Ngram_map_t map_Score_by_Ngram;
		Word* p_StartWord;
		Word* p_EndWord;

		pair <double, double> GetNGramProb (Word_dq_t& _dqWords, 
											Word* _pNextWord,
											int _iStart, int _iLength, 
											WordRenderer_t _pRenderer,
											bool _bIgnoreTerminals = false);


	public:
		unsigned int i_Order;

		LanguageModel (void);
		~LanguageModel (void);

		void Train (const char* _zInputFilePath, 
					const char* _zArpaFilaPath, 
					int _iOrder, 
					const char* _zSRILMOptions);
  		void LoadARPAFile (const char* _zFileName);
		
		pair <double, double> Get (Word_dq_t& _dqWords, 
									Word* _pNextWord, 
									WordRenderer_t _pRenderer, 
									bool _bIgnoreTerminals);
		pair <double, double> GetFullScore (Word_dq_t& _dqWords, 
											Word* _pNextWord, 
											WordRenderer_t _pRenderer, 
											bool _bIgnoreTerminals);
};


#endif
