#ifndef __TITLE_GEN_PERCEPTRON__
#define __TITLE_GEN_PERCEPTRON__

#include <map>
#include "hash_map.hpp"
#include <list>
#include "nlp_string.h"
#include "Features.h"

class FeatureVector;
typedef hash_map <String, double>		FeatureValue_map_t;
typedef list <FeatureValue_map_t*>		Weights_list_t;
typedef list <FeatureVector*>			Feature_Vector_list_t;


class Perceptron 
{
	private:
		double	arr_Weights [FEATURE_COUNT];
		int		arr_AllowUpdate [FEATURE_COUNT];
		bool	b_ReadOnly;

	public:
		bool	b_Hierarchical;

		Perceptron();
		~Perceptron();

		void Update (FeatureVector& _rYGood, Feature_Vector_list_t& _lstBad);
		double Evaluate (FeatureVector& _rFeatures);

		void Save (const char* _zFileName, const char* _zTag);
		bool Load (const char* _zFileName);
		void LoadReadOnly (const char* _zFileName);
		void LoadLastWeights (ifstream& file);
		void LoadAverageWeights (ifstream& file);
};


#include "FeatureVector.h"
#endif
