// =============================================================
//  AUTHOR      : S.R.K. Branavan								
//  DATE        : 11/09/2006									
//  FILE        : String.cpp									
// =============================================================

#include <iostream>
#include <assert.h>
#include <strings.h>
#include "nlp_string.h"
using namespace std;


String::String (void)
	: string ()
{
}

String::String (const char* _zText)
	: string (_zText)
{
}

String::String (const String& _sText)
	: string (_sText.c_str ())
{
}

String::String (const string& _sText)
	: string (_sText.c_str ())
{
}

String::String (const list <String>& _rList)
{
	Join (_rList);
}

String::String (const list <string>& _rList)
{
	Join (_rList);
}

//==========================================================================
int String::Compare (const String& _rString)
{
	return (((string&)*this) == (string&) _rString);
}

int String::Compare (const char* _zValue)
{
	return (std::operator== (*this, _zValue));
}

int String::Compare (const char _cValue)
{
	const char* pThisString = c_str ();
	if (NULL == pThisString)
		return false;
	if ((pThisString [0] == _cValue) && (pThisString [1] == '\0'))
		return true;
	return false;
}

//==========================================================================
int String::CaseCompare (const String& _rString)
{
	return (strcasecmp (c_str (), _rString.c_str ()));
}

int String::CaseCompare (const char* _zValue)
{
	return (strcasecmp (c_str (), _zValue));
}

int String::CaseCompare (const char _cValue)
{
	const char* pThisString = c_str ();
	if (NULL == pThisString)
		return false;
	if (((0x20 | pThisString [0]) == (0x20 | _cValue)) && (pThisString [1] == '\0'))
		return true;
	return false;
}


//==========================================================================
bool String::IsAlNum (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (false == isalnum (*(p++)))
            return false;
    return true;
}


bool String::IsAlpha (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (false == isalpha (*(p++)))
            return false;
    return true;
}


bool String::IsDigit (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (false == isdigit (*(p++)))
            return false;
    return true;
}


bool String::IsSpace (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (false == isspace (*(p++)))
            return false;
    return true;
}


bool String::IsLower (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (true == isupper (*(p++)))
            return false;
    return true;
}


bool String::IsUpper (void)
{
    register const char* p = c_str ();
    while ('\0' != *p)
        if (false == isupper (*(p++)))
            return false;
    return true;
}


bool String::IsTitle (void)
{
    cerr << "String::IsTitle not implemented." << endl;
    assert (false);
}








