// =============================================================
//  AUTHOR      : S.R.K. Branavan								
//  DATE        : 11/09/2006									
//  FILE        : String.cpp									
// =============================================================

#include <string.h>
#include "nlp_string.h"


//---------------------------------------------------------------------------------
long String::Count (const char* _zSubString, long _lStart, long _lEnd)
{
    register long lLength = length ();
    if (-1 == _lEnd)
        _lEnd = lLength;
    else if (_lEnd > lLength)
        _lEnd = lLength;
    else if (_lEnd <= 0)
        return 0;
    if (_lStart >= _lEnd)
        return 0;

    register long lSubStringLength = strlen (_zSubString);
    const char* pString = c_str ();
    const char* pStart = pString + _lStart;

    long lCount = 0;
    register const char* p = strstr (pStart, _zSubString);
    while (NULL != p)
    {
        if ((long) (p - pString) + lSubStringLength > lLength)
            return lCount;
        ++ lCount;
        p = strstr (p + lSubStringLength, _zSubString);
    }
    return lCount;
}


//---------------------------------------------------------------------------------
string::size_type String::Find (const char* _zSubString, long _lStart, long _lEnd)
{
    size_type iSubStringIndex = string::find (_zSubString, _lStart);
    if (iSubStringIndex == string::npos)
        return string::npos;
    if (iSubStringIndex > (string::size_type) _lEnd)
        return string::npos;
    
    return iSubStringIndex;
}


//---------------------------------------------------------------------------------
string::size_type String::ReverseFind (const char* _zSubString, long _lStart, long _lEnd)
{
    if (0 < _lEnd)
        _lEnd = length ();
    size_type iSubStringIndex = string::rfind (_zSubString, _lEnd);
    if (iSubStringIndex == string::npos)
        return string::npos;
    if (iSubStringIndex < (string::size_type) _lStart)
        return string::npos;
    
    return iSubStringIndex;
}




