#ifndef __TITLE_GEN_TAGGER__
#define __TITLE_GEN_TAGGER__

#include "nlp_string.h"
#include "hash_map.hpp"
#include "BookSection.h"



typedef list <String>			    	        Unigram_list_t;
typedef hash_map <String, double>		        Weight_by_Ngram_map_t;
typedef hash_map <String, int>					Tag_to_Count_map_t;
typedef hash_map <String, Tag_to_Count_map_t>	Word_to_TagCount_map_t;
typedef hash_map <String, String>				Word_to_Tag_map_t;



class Tagger
{
	private:
		void WriteTagInputBySection (BookSection* _pSection, ofstream& _rFile);
		void ParseTaggedOutput (const char* _zFileName, BookSection_list_t& _rlstSections); 
		void ParseTaggedOutputBySection (ifstream& _rFile, BookSection* _pSection); 
		void SetWordTags (String& _sParsedSentence, Sentence* _pSentence);
		void CheckForUntaggedWords (BookSection* _pSection);

	public:
		Tagger (void);
		~Tagger (void);
		
		void TagCorpus (BookSection* _pRootSection);
		void TagFromFile (BookSection* _pRootSection);
		void TagTitlesFromText (BookSection* _pRootSection);
		
};


#endif
