#ifndef __NLP_UTILS__
#define __NLP_UTILS__

#include "nlp_string.h"
#include "Section.h"
#include "BookSection.h"
#include <set>

using namespace std;



class Utils
{
    public:
        static Unigram_set_t set_NP_Tags;

        static void CleanText (String& _rText);
        static void TokenizeText (String& _rText);
        static void SplitIntoWords (String& _rText, list <String>& _lstWords);
        static void SplitIntoSentences (String& _rText, list <String>& _lstSentences);
		static void ExtractNounPhrases (Ngram_list_t &_lstNgramList, Word_dq_t& _rdqWords);
		static void ExtractNounPhrases (Ngram_list_t &_lstNgramList, String *_sAllWords, Word_list_t *_lstWordList);
		static void DeleteNgramList (Ngram_list_t  &_lstNgramList);
		static void StemWord (String& _pStem, const char* _zWord);
		static void WordListToTagList (Unigram_list_t &_lstNgramTags, Word_list_t* _lstWords);
		static void WordListToTagList (Unigram_list_t &_lstNgramTags, Word_dq_t& _dqWords, long _lLength = -1);
		static void WordListToNgramString (String &_sNgram, Word_list_t* _plstWords, Word* _pWord = NULL);
		static void WordListToNgramString (String &_sNgram, Word_dq_t* _pdqWords, Word* _pWord = NULL);
		static int GetTitleWordLength (String _sTitle);
		static void GetInOrderSectionList (Section_list_t &_lstSections, Section* _pSubRootSection);
		static void GetInOrderSectionList (BookSection_list_t &_lstSections, BookSection* _pSubRootSection);
		static void SectionsAtDepth (Section_dq_t& _dqSections, Section* _pRoot, int _iDepth);
		static void SectionsAtDepth (BookSection_dq_t& _dqSections, BookSection* _pRoot, int _iDepth);
		static int SetIntersectionSize (Unigram_set_t &_setOne, Unigram_set_t &_setTwo);
};


#endif
